
||----------------------------------------------------------------------|| 
||									||
||	semantic_types.m						||
||									||
||	The types underlying the semantic interpretation of the		||
||	simple imperative language whose syntax appears in		||
||		basic_abstract_syntax.m					||
||									||
||	(c) Simon Thompson, 1995					||
||									||
||----------------------------------------------------------------------|| 

%free	{ ident :: type
	}

||----------------------------------------------------------------------|| 
||									||
||	Stores and environments are defined here. They can be		||
||	thought of as abstract types with a limited interface		||
||	to the rest of the semantics.					||
||									||
||----------------------------------------------------------------------|| 

	update :: stores -> ident -> num -> stores
	lookup :: ident -> stores -> num

||----------------------------------------------------------------------||
||	Implementation of the type of stores.				||
||									||
||	The type is represented by association lists, pairs of		||
||		( index , datum	)					||
||	objects. Numerous other implementations exist, of course.	||
||----------------------------------------------------------------------|| 

stores == [( ident , num )]			

update x i val = (i,val):x

lookup i [] = error "lookup"
lookup i ((j,val):x) = val 			, if i=j
		     = lookup i x		, otherwise

