||----------------------------------------------------------------------|| 
||									||
||	examples.m							||
||									||
||	Example programs in the abstract syntax for the language	||
||	whose operational semantics is specified in this directory.	||
||									||
||	(c) Simon Thompson, 1995					||
||									||
||----------------------------------------------------------------------|| 

%include "abstract_syntax"

||----------------------------------------------------------------------||
||									||
||	Example programs						||
||	are given by the expressions					||
||	example, example3  and example4 				||
||									||
||----------------------------------------------------------------------||

com1 = Assignment a (Num 2)

a = Name "a"

com2 = Assignment b (Num 3)

b = Name "b"

com3 = While_Do (Apply_rel Greater (Var a) (Num 0)) com4

com4 = Sequence [ (Assignment b (Apply_nop Add (Var b) (Num 1))) ,
		  (Assignment a (Apply_nop Subtract (Var a) (Num 1))) ]

example = Sequence [com1,com2,com3]

expr1 = (Apply_nop Add (Var b) (Num 1))
||----------------------------------------------------------------------||
||									||
||	example is							||
||									||
||	a := 2;		{com1}						||
||	b := 3;		{com2}						||
||	while (a>0) do	{com3}						||
||		begin							||
||		b:=b+1; {com4}						||
||		a:=a-1							||
||		end							||
||									||
||	output prints the pair of values (a,b) on termination,		||
||	after running the program on the initially empty store, st0.	||
||									||
||	Example 3 gives							||
||	a := 2;		{com1}						||
||	b := 3;		{com2}						||
||	a := b;								||
||	b := a;								||
||									||
||----------------------------------------------------------------------||

example3 = Sequence [ com1 , com2 ,
  		Sequence [ Assignment a (Var b) ,Assignment b (Var a) ] ]

example4 = Sequence [ example , example , example3,
		(While_Do expo example3) , 
		(If_Then_Else expo2 example example3) ]

expo = Apply_bop And (Apply_rel Greater_eq
			(Apply_nop Multiply (Var a) (Var b))	
			(Apply_monop Minus (Num 37)))
		     (Bool False)

expo2 = expo

non_term = While_Do (Bool True) Skip

non_term2 = While_Do (Bool True) 
		(Assignment a
			    (Apply_nop Add (Var a) (Num 1)))
