||----------------------------------------------------------------------|| 
||									||
||	semantics_d.m							||
||									||
||	Pulling the (dynamic binding) semantics together.		||
||									||
||	(c) Simon Thompson, 1995					||
||									||
||----------------------------------------------------------------------|| 

||----------------------------------------------------------------------|| 
||									||
||	The file pulling together all the definitions making up the	||
||	static binding semantics of the language whose syntax		||
||	appears in the file abstract_syntax.m.				||
||									||
||	The files containing the syntax and the basic semantic types 	||
||	can be compiled separately, with the one proviso that the	||
||	identifier `ident' is free in the semantic_types_d.m file.	||
||									||
||	The recursions in the ..._values_d.m files are so tightly	||
||	coupled that it is difficult to see how they may be 		||
||	modularised, and so we have used the textual insertion 		||
||	mechanism to split them into four (related) text files.		||
||									||
||	To allow files including this one to use the syntax and		||
||	the basic semantic types, the two files are subject to an	||
||	export directive.						||
||									||
||----------------------------------------------------------------------|| 


%export + "abstract_syntax" "semantic_types_d"

%include "abstract_syntax"
%include "semantic_types_d" { ident == ident 
			  }

%include "origami"


%insert "sem_fun_types_d.ins"

%insert "command_values_d.ins" 

%insert "def_values_d.ins" 

%insert "expr_values.ins"

%insert "proc_values_d.ins" 


