
||----------------------------------------------------------------------|| 
||									||
||	top_level_d.m							||
||									||
||	Putting together the (dynamic) semantics, the pretty printer	||
||	and the examples.						||
||									||
||	(c) Simon Thompson, 1995					||
||									||
||----------------------------------------------------------------------|| 

%include "semantics_d"

%include "examples"

%include "pretty"

run :: command -> [char]

run c = "\nThe effect of the command:\n\n" ++ pretty c ++ 
	   "\n\nwith empty initial store and environment" ++
	   " and using dynamic binding\n" ++
	   "is to produce the store\n\n" ++
	   show_final (command_value c [] [])

show_final :: stores -> [char]

show_final = show_store . get_final

get_final :: stores -> stores

get_final [] = []
get_final ((a,b):rest) = (a,b) : get_final [ (c,d) | (c,d) <- rest ; c~=a ]

show_store :: stores -> [char]

show_num :: num -> [char]
show_num = show

show_store st = header ++ ( concat (map show_pair st) )
		where
		show_pair ( a , Number b )
			= "\t" ++ show_num a ++"\t"++ show_num b ++ "\n"
		header = "\nlocation\tvalue\n\n"

