||----------------------------------------------------------------------|| 
||									||
||	code.m								||
||									||
||	(c) Simon Thompson, 1995					||
||									||
||	The machine code for a simple, stack-based, abstract machine.	||
||	The stack is used to hold all intermediate values, of type	||
||	num and bool, and to hold locations too (whilst assignments 	||
||	are going on). Values are tagged as necessary.			||
||									||
||	We use the abstract syntax for simple operations of arithmetic	||
||	etc.								||
||									||
||----------------------------------------------------------------------|| 

%include "../full/abstract_syntax"

m_code ::= Push_num num |
  	   Do_nop nop |
	   Do_monop monop |
	   Contents ident |
	   Push_bool bool |
	   Do_rel rel |
	   Do_bop bop |
	   Do_monbop monbop |
	   Lval ident |
	   Pop |
	   Assign |
	   Copy |
	   Label label |
	   Goto label |
	   Gofalse label |
	   Gotrue label |
	   Halt

label == num

||----------------------------------------------------------------------|| 
||	Labels are taken to be numbers.					||
||----------------------------------------------------------------------|| 
